#!/usr/bin/env python2.7
from __future__ import absolute_import, division, print_function
import utool as ut
import os
from os.path import dirname  # NOQA
from utool._internal import util_importer


def makeinit(module_path, exclude_modnames=[]):
    #module_name = basename(module_path)
    module_name = ut.get_modname_from_modpath(module_path)
    IMPORT_TUPLES = util_importer.make_import_tuples(module_path, exclude_modnames=exclude_modnames)
    initstr = util_importer.make_initstr(module_name, IMPORT_TUPLES)
    regen_command = 'cd %s\n' % (module_path)
    regen_command += '    makeinit.py'
    if len(exclude_modnames ) > 0:
        regen_command += ' -x ' + ' '.join(exclude_modnames)
    regen_block = (ut.codeblock('''
    """
    Regen Command:
        {regen_command}
    """
    ''').format(regen_command=regen_command))

    print('### __init__.py ###')
    print(initstr)
    print('\nIMPORT_TUPLES = ' + ut.list_str(IMPORT_TUPLES))
    print(regen_block)


if __name__ == '__main__':
    exclude_modnames = ut.get_argval(('--exclude', '-x'), list, default=[])
    modname = ut.get_argval('--modname', str, default=None)
    if modname is None:
        dpath = os.getcwd()
    else:
        dpath = ut.get_modpath_from_modname(modname)
    module_path = ut.unixpath(dpath)
    makeinit(module_path, exclude_modnames=exclude_modnames)
    print('# autogenerated __init__.py for: %r' % module_path)
